SystemOrganization addCategory: #Colors!

!Color class methodsFor: '*Colors' stamp: 'spfa 12/10/2005 10:13'!
displayNamedColors

	"Color displayNamedColors"

	| ts |
	ts _ TextStream on: Text new.
	Color colorNames do: [:n | 
		| col aMorph bMorph coloredText |
		col _ Color perform: n.
		coloredText _ n asText addAttribute: (TextColor color: col).	
		aMorph _ Morph new extent: 100@ (TextStyle defaultFont height); 
						color: col; textAnchorType: #inline.
		bMorph _ aMorph veryDeepCopy color: Color black; width: 150; 
						addMorph: (TextMorph new contents: coloredText).
		ts nextPutAll: (Text string: (String value: 1) attribute: (TextAnchor new anchoredMorph: bMorph));
		nextPutAll: '   ';
		nextPutAll: (Text string: (String value: 1) attribute: (TextAnchor new anchoredMorph: aMorph));
		nextPutAll: ' ', n, ' (';
		nextPutAll: coloredText;
		nextPutAll: ')';
		nextPutAll: String cr].

	(Workspace new contents: ts contents) 	openLabel: 'named colors'! !

!Color methodsFor: '*Colors' stamp: 'spfa 12/7/2004 22:28'!
xorWheel: thisMany angle: angle
	"An array of thisMany colors around the color wheel starting some way after self and ending all the way around the hue space  before self.  Array is of length thisMany. angle defines which area around self is to be excluded "

	| sat bri hue step c |
	sat _ self saturation.
	bri _ self brightness.
	hue _ self hue + (angle / 2).
	step _ (360.0 - angle) / (thisMany max: 1).
	^ (1 to: thisMany) collect: [:num |
		c _ Color h: hue s: sat v: bri.  "hue is taken mod 360"
		hue _ hue + step.
		c].
! !

Object subclass: #MoreColors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Colors'!

!MoreColors commentStamp: 'spfa 12/8/2005 11:35' prior: 0!
The initialization of this class added 143 new named colors.
 
Color displayNamedColors "doIt"!

!MoreColors class methodsFor: 'class initialization' stamp: 'spfa 12/8/2005 11:23'!
colors

	^ self rebuilt:  'H4sIAAAAAAAAAG2Wa2wUVRSAF7rd7XZLH/gE5FVelTZLRCzvNm2JRMCWFFIwxDR3Z+7uXHZ2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'! !

!MoreColors class methodsFor: 'class initialization' stamp: 'spfa 12/8/2005 11:34'!
initialize

	self colors do: [:ea |
			(Color colorNames includes: ea key) ifFalse: [Color named: ea key put: ea value]].


! !

!MoreColors class methodsFor: 'class initialization' stamp: 'spfa 12/8/2005 11:15'!
rebuilt: aString

	"code borrowed from the InstanceEncoder package"

	| decoded unzipped referenceStream object |

	decoded _ RWBinaryOrTextStream on: (ByteArray new: 5000).
	Base64MimeConverter
		mimeDecode: aString
		to: decoded.
	decoded reset.

	unzipped _ RWBinaryOrTextStream with: ((GZipReadStream on: decoded) upToEnd).

	referenceStream _ ReferenceStream on:  unzipped reset.
	object _ referenceStream next.
	referenceStream close.
	
	^ object	! !
MoreColors initialize!
